## restbed 4.0~dfsg1

=== CMakeLists.txt ===
# Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.

project( "restbed" )

cmake_minimum_required( VERSION 2.8.10 )

#
# Build Options
#
option( BUILD_SHARED   "Build shared library."              OFF )
option( BUILD_EXAMPLES "Build examples applications."       OFF )
option( BUILD_TESTS    "Build all available test suites."   OFF )
option( BUILD_SSL      "Build secure socket layer support."  ON )

#
# Configuration
#
include( "${CMAKE_SOURCE_DIR}/cmake/build_configuration.cmake" )

message( "   ${Blue}Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.${Reset}" )

#
# Dependencies
#
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules" )

find_package( asio REQUIRED )
include_directories( SYSTEM ${asio_INCLUDE} )

if ( BUILD_SSL )
    find_package( openssl REQUIRED )
    include_directories( SYSTEM ${ssl_INCLUDE} )
endif ( )

#
# Build
#
include( "${CMAKE_SOURCE_DIR}/cmake/build_manifest.cmake" )

include_directories( ${INCLUDE_DIR} )

add_library( ${PROJECT_NAME} ${BUILD_MANIFEST} )

if ( BUILD_SSL )
    target_link_libraries( ${PROJECT_NAME} LINK_PRIVATE ${ssl_LIBRARY} ${crypto_LIBRARY} )
else ( )
    target_link_libraries( ${PROJECT_NAME} )
endif ( )

if ( BUILD_EXAMPLES )
    find_package( pam )
    find_package( syslog )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/example" )
endif ( )

if ( BUILD_TESTS )
    find_package( catch REQUIRED )

    enable_testing( )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/unit" "unit-tests" )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/acceptance" "acceptance-tests" )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/regression" "regression-tests" )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/integration" "integration-tests" )
endif ( )

#
# Install
#
include( "${CMAKE_SOURCE_DIR}/cmake/build_artifacts.cmake" )

install( FILES "${INCLUDE_DIR}/${PROJECT_NAME}" DESTINATION "include" )
install( FILES ${BUILD_ARTIFACTS} DESTINATION "include/corvusoft/${PROJECT_NAME}" )
install( TARGETS ${PROJECT_NAME}
         LIBRARY DESTINATION "library"
         ARCHIVE DESTINATION "library" COMPONENT library )

=== example/CMakeLists.txt ===
# Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.

project( "example" )

cmake_minimum_required( VERSION 2.8.10 )

#
# Configuration
#
set( EXECUTABLE_OUTPUT_PATH "${CMAKE_CURRENT_BINARY_DIR}/example" )

#
# Build
#
add_executable( basic_authentication basic_authentication/source/example.cpp )
target_link_libraries( basic_authentication ${CMAKE_PROJECT_NAME} )

add_executable( authentication authentication/source/example.cpp )
target_link_libraries( authentication ${CMAKE_PROJECT_NAME} )

add_executable( custom_status_codes custom_status_codes/source/example.cpp )
target_link_libraries( custom_status_codes ${CMAKE_PROJECT_NAME} )

add_executable( digest_authentication digest_authentication/source/example.cpp )
target_link_libraries( digest_authentication ${CMAKE_PROJECT_NAME} )

add_executable( error_handling error_handling/source/example.cpp )
target_link_libraries( error_handling ${CMAKE_PROJECT_NAME} )

add_executable( logging logging/source/example.cpp )
target_link_libraries( logging ${CMAKE_PROJECT_NAME} )

add_executable( path_parameters path_parameters/source/example.cpp )
target_link_libraries( path_parameters ${CMAKE_PROJECT_NAME} )

add_executable( publishing_resources publishing_resources/source/example.cpp )
target_link_libraries( publishing_resources ${CMAKE_PROJECT_NAME} )

add_executable( custom_methods custom_methods/source/example.cpp )
target_link_libraries( custom_methods ${CMAKE_PROJECT_NAME} )

add_executable( publishing_multipath_resources publishing_multipath_resources/source/example.cpp )
target_link_libraries( publishing_multipath_resources ${CMAKE_PROJECT_NAME} )

add_executable( resource_filtering resource_filtering/source/example.cpp )
target_link_libraries( resource_filtering ${CMAKE_PROJECT_NAME} )

add_executable( serving_html serving_html/source/example.cpp )
target_link_libraries( serving_html ${CMAKE_PROJECT_NAME} )

add_executable( transfer_encoding_request transfer_encoding_request/source/example.cpp )
target_link_libraries( transfer_encoding_request ${CMAKE_PROJECT_NAME} )

add_executable( transfer_encoding_response transfer_encoding_response/source/example.cpp )
target_link_libraries( transfer_encoding_response ${CMAKE_PROJECT_NAME} )

add_executable( persistent_connection persistent_connection/source/example.cpp )
target_link_libraries( persistent_connection ${CMAKE_PROJECT_NAME} )

add_executable( compression compression/source/example.cpp )
target_link_libraries( compression ${CMAKE_PROJECT_NAME} )

add_executable( http_service http_service/source/example.cpp )
target_link_libraries( http_service ${CMAKE_PROJECT_NAME} )

add_executable( service_ready_handler service_ready_handler/source/example.cpp )
target_link_libraries( service_ready_handler ${CMAKE_PROJECT_NAME} )

add_executable( session_data session_data/source/example.cpp )
target_link_libraries( session_data ${CMAKE_PROJECT_NAME} )

add_executable( rules_engine rules_engine/source/example.cpp )
target_link_libraries( rules_engine ${CMAKE_PROJECT_NAME} )

add_executable( multithreaded_service multithreaded_service/source/example.cpp )
target_link_libraries( multithreaded_service ${CMAKE_PROJECT_NAME} )

add_executable( schedule_work_on_service_runloop schedule_work_on_service_runloop/source/example.cpp )
target_link_libraries( schedule_work_on_service_runloop ${CMAKE_PROJECT_NAME} )

add_executable( bind_service_address bind_service_address/source/example.cpp )
target_link_libraries( bind_service_address ${CMAKE_PROJECT_NAME} )

add_executable( session_manager session_manager/source/example.cpp )
target_link_libraries( session_manager ${CMAKE_PROJECT_NAME} )

add_executable( http_client http_client/source/example.cpp )
target_link_libraries( http_client ${CMAKE_PROJECT_NAME} )

add_executable( signal_handling signal_handling/source/example.cpp )
target_link_libraries( signal_handling ${CMAKE_PROJECT_NAME} )

if ( PAM_FOUND )
    add_executable( pam_authentication pam_authentication/source/example.cpp )
    target_link_libraries( pam_authentication ${CMAKE_PROJECT_NAME} pam )
endif ( )

if ( SYSLOG_FOUND )
    add_executable( syslog_logging syslog_logging/source/example.cpp )
    target_link_libraries( syslog_logging ${CMAKE_PROJECT_NAME} )
endif ( )

if ( BUILD_SSL )
    add_executable( https_service https_service/source/example.cpp )
    target_link_libraries( https_service ${CMAKE_PROJECT_NAME} )

    add_executable( https_client_verify_none https_client/source/verify_none.cpp )
    target_link_libraries( https_client_verify_none ${CMAKE_PROJECT_NAME} )

    add_executable( https_client_verify_peer https_client/source/verify_peer.cpp )
    target_link_libraries( https_client_verify_peer ${CMAKE_PROJECT_NAME} )
endif ( )

#
# Install
#
install( DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/example" DESTINATION ${CMAKE_INSTALL_PREFIX} FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE )

install( DIRECTORY "${CMAKE_SOURCE_DIR}/example/https_client/resource/certificates" DESTINATION "${CMAKE_INSTALL_PREFIX}/resource" FILE_PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE )

install( FILES "${CMAKE_SOURCE_DIR}/example/serving_html/resource/index.html" DESTINATION "resource" )
install( FILES "${CMAKE_SOURCE_DIR}/example/compression/resource/data.zlib" DESTINATION "resource" )
install( FILES "${CMAKE_SOURCE_DIR}/example/transfer_encoding_request/resource/request.txt" DESTINATION "resource" )

=== test/acceptance/CMakeLists.txt ===
# Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.

project( "acceptance test suite" )

cmake_minimum_required( VERSION 2.8.10 )

#
# Configuration
#
set( SOURCE_DIR "source" )
set( HELPERS_DIR "${CMAKE_SOURCE_DIR}/test/helpers/source" )
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCATCH_CONFIG_MAIN" )

include_directories( SYSTEM ${catch_INCLUDE} ${asio_INCLUDE} )

#
# Build
#
add_executable( publishing_single_path_resources_http_get_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_get.cpp )
target_link_libraries( publishing_single_path_resources_http_get_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_get_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_get_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_put_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_put.cpp )
target_link_libraries( publishing_single_path_resources_http_put_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_put_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_put_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_head_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_head.cpp )
target_link_libraries( publishing_single_path_resources_http_head_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_head_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_head_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_post_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_post.cpp )
target_link_libraries( publishing_single_path_resources_http_post_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_post_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_post_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_trace_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_trace.cpp )
target_link_libraries( publishing_single_path_resources_http_trace_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_trace_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_trace_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_patch_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_patch.cpp )
target_link_libraries( publishing_single_path_resources_http_patch_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_patch_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_patch_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_delete_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_delete.cpp )
target_link_libraries( publishing_single_path_resources_http_delete_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_delete_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_delete_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_connect_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_connect.cpp )
target_link_libraries( publishing_single_path_resources_http_connect_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_connect_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_connect_acceptance_test_suite )

add_executable( publishing_single_path_resources_http_options_acceptance_test_suite ${SOURCE_DIR}/publishing_single_path_resources/http_options.cpp )
target_link_libraries( publishing_single_path_resources_http_options_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_single_path_resources_http_options_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_single_path_resources_http_options_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_get_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_get.cpp )
target_link_libraries( publishing_multi_path_resources_http_get_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_get_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_get_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_put_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_put.cpp )
target_link_libraries( publishing_multi_path_resources_http_put_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_put_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_put_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_head_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_head.cpp )
target_link_libraries( publishing_multi_path_resources_http_head_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_head_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_head_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_post_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_post.cpp )
target_link_libraries( publishing_multi_path_resources_http_post_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_post_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_post_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_trace_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_trace.cpp )
target_link_libraries( publishing_multi_path_resources_http_trace_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_trace_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_trace_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_patch_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_patch.cpp )
target_link_libraries( publishing_multi_path_resources_http_patch_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_patch_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_patch_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_delete_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_delete.cpp )
target_link_libraries( publishing_multi_path_resources_http_delete_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_delete_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_delete_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_connect_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_connect.cpp )
target_link_libraries( publishing_multi_path_resources_http_connect_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_connect_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_connect_acceptance_test_suite )

add_executable( publishing_multi_path_resources_http_options_acceptance_test_suite ${SOURCE_DIR}/publishing_multi_path_resources/http_options.cpp )
target_link_libraries( publishing_multi_path_resources_http_options_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( publishing_multi_path_resources_http_options_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/publishing_multi_path_resources_http_options_acceptance_test_suite )

add_executable( custom_http_methods_http_get_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_get.cpp )
target_link_libraries( custom_http_methods_http_get_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_get_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_get_acceptance_test_suite )

add_executable( custom_http_methods_http_put_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_put.cpp )
target_link_libraries( custom_http_methods_http_put_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_put_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_put_acceptance_test_suite )

add_executable( custom_http_methods_http_head_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_head.cpp )
target_link_libraries( custom_http_methods_http_head_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_head_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_head_acceptance_test_suite )

add_executable( custom_http_methods_http_post_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_post.cpp )
target_link_libraries( custom_http_methods_http_post_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_post_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_post_acceptance_test_suite )

add_executable( custom_http_methods_http_trace_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_trace.cpp )
target_link_libraries( custom_http_methods_http_trace_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_trace_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_trace_acceptance_test_suite )

add_executable( custom_http_methods_http_patch_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_patch.cpp )
target_link_libraries( custom_http_methods_http_patch_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_patch_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_patch_acceptance_test_suite )

add_executable( custom_http_methods_http_delete_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_delete.cpp )
target_link_libraries( custom_http_methods_http_delete_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_delete_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_delete_acceptance_test_suite )

add_executable( custom_http_methods_http_connect_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_connect.cpp )
target_link_libraries( custom_http_methods_http_connect_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_connect_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_connect_acceptance_test_suite )

add_executable( custom_http_methods_http_options_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_options.cpp )
target_link_libraries( custom_http_methods_http_options_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_options_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_options_acceptance_test_suite )

add_executable( custom_http_methods_http_invoke_acceptance_test_suite ${SOURCE_DIR}/custom_http_methods/http_invoke.cpp )
target_link_libraries( custom_http_methods_http_invoke_acceptance_test_suite ${CMAKE_PROJECT_NAME} )
add_test( custom_http_methods_http_invoke_acceptance_test_suite ${EXECUTABLE_OUTPUT_PATH}/custom_http_methods_http_invoke_acceptance_test_suite )

add_executable( http_method_handlers_http_get_acceptance_test_suite ${SOURCE_DIR}/http_method_handlers/http_get.cpp )
target_link_libraries( http_method_handlers_http_get_acceptance_test_suite ${CMAKE_PROJECT_NAME} )

=== test/regression/CMakeLists.txt ===
# Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.

project( "regression test suite" )

cmake_minimum_required( VERSION 2.8.10 )

#
# Configuration
#
set( SOURCE_DIR "source" )
set( HELPERS_DIR "${CMAKE_SOURCE_DIR}/test/helpers/source" )
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCATCH_CONFIG_MAIN" )

include_directories( SYSTEM ${catch_INCLUDE} ${asio_INCLUDE} )

#
# Build
#
add_executable( resources_are_not_overwritten_regression_test_suite ${SOURCE_DIR}/resources_are_not_overwritten.cpp )
target_link_libraries( resources_are_not_overwritten_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( resources_are_not_overwritten_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/resources_are_not_overwritten_regression_test_suite )

add_executable( missing_regex_support_on_gcc_4.8_regression_test_suite ${SOURCE_DIR}/missing_regex_support_on_gcc_4.8.cpp )
target_link_libraries( missing_regex_support_on_gcc_4.8_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( missing_regex_support_on_gcc_4.8_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/missing_regex_support_on_gcc_4.8_regression_test_suite )

add_executable( request_uris_are_not_being_decoded_regression_test_suite ${SOURCE_DIR}/request_uris_are_not_being_decoded.cpp )
target_link_libraries( request_uris_are_not_being_decoded_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( request_uris_are_not_being_decoded_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/request_uris_are_not_being_decoded_regression_test_suite )

add_executable( resource_responding_on_invalid_path_regression_test_suite ${SOURCE_DIR}/resource_responding_on_invalid_path.cpp )
target_link_libraries( resource_responding_on_invalid_path_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( resource_responding_on_invalid_path_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/resource_responding_on_invalid_path_regression_test_suite )

add_executable( segmentation_fault_on_mismatched_path_regression_test_suite ${SOURCE_DIR}/segmentation_fault_on_mismatched_path.cpp )
target_link_libraries( segmentation_fault_on_mismatched_path_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( segmentation_fault_on_mismatched_path_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/segmentation_fault_on_mismatched_path_regression_test_suite )

add_executable( exception_thrown_with_space_in_resource_path_regression_test_suite ${SOURCE_DIR}/exception_thrown_with_space_in_resource_path.cpp )
target_link_libraries( exception_thrown_with_space_in_resource_path_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( exception_thrown_with_space_in_resource_path_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/exception_thrown_with_space_in_resource_path_regression_test_suite )

add_executable( uncaught_exception_when_peer_closes_connection_regression_test_suite ${SOURCE_DIR}/uncaught_exception_when_peer_closes_connection.cpp )
target_link_libraries( uncaught_exception_when_peer_closes_connection_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( uncaught_exception_when_peer_closes_connection_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/uncaught_exception_when_peer_closes_connection_regression_test_suite )

add_executable( error_handler_not_overwritten_regression_test_suite ${SOURCE_DIR}/error_handler_not_overwritten.cpp )
target_link_libraries( error_handler_not_overwritten_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( error_handler_not_overwritten_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/error_handler_not_overwritten_regression_test_suite )

add_executable( large_request_bodies_being_trimmed_regression_test_suite ${SOURCE_DIR}/large_request_bodies_being_trimmed.cpp )
target_link_libraries( large_request_bodies_being_trimmed_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( large_request_bodies_being_trimmed_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/large_request_bodies_being_trimmed_regression_test_suite )

add_executable( fails_to_parse_identical_query_parameters_regression_test_suite ${SOURCE_DIR}/fails_to_parse_identical_query_parameters.cpp )
target_link_libraries( fails_to_parse_identical_query_parameters_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( fails_to_parse_identical_query_parameters_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/fails_to_parse_identical_query_parameters_regression_test_suite )

add_executable( content_length_present_on_empty_response_body_regression_test_suite ${SOURCE_DIR}/content_length_present_on_empty_response_body.cpp )
target_link_libraries( content_length_present_on_empty_response_body_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( content_length_present_on_empty_response_body_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/content_length_present_on_empty_response_body_regression_test_suite )

add_executable( content_type_present_on_empty_response_body_regression_test_suite ${SOURCE_DIR}/content_type_present_on_empty_response_body.cpp )
target_link_libraries( content_type_present_on_empty_response_body_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( content_type_present_on_empty_response_body_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/content_type_present_on_empty_response_body_regression_test_suite )

add_executable( resource_instance_destroyed_with_bound_method_functors_regression_test_suite ${SOURCE_DIR}/resource_instance_destroyed_with_bound_method_functors.cpp )
target_link_libraries( resource_instance_destroyed_with_bound_method_functors_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( resource_instance_destroyed_with_bound_method_functors_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/resource_instance_destroyed_with_bound_method_functors_regression_test_suite )

add_executable( fails_to_parse_header_values_containing_colons_regression_test_suite ${SOURCE_DIR}/fails_to_parse_header_values_containing_colons.cpp )
target_link_libraries( fails_to_parse_header_values_containing_colons_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( fails_to_parse_header_values_containing_colons_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/fails_to_parse_header_values_containing_colons_regression_test_suite )

add_executable( string_replace_fails_to_replace_embedded_targets_regression_test_suite ${SOURCE_DIR}/string_replace_fails_to_replace_embedded_targets.cpp )
target_link_libraries( string_replace_fails_to_replace_embedded_targets_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( string_replace_fails_to_replace_embedded_targets_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/string_replace_fails_to_replace_embedded_targets_regression_test_suite )

add_executable( path_parameters_are_not_visible_within_rules_regression_test_suite ${SOURCE_DIR}/path_parameters_are_not_visible_within_rules.cpp )
target_link_libraries( path_parameters_are_not_visible_within_rules_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( path_parameters_are_not_visible_within_rules_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/path_parameters_are_not_visible_within_rules_regression_test_suite )

add_executable( request_get_parameters_fails_to_return_data_regression_test_suite ${SOURCE_DIR}/request_get_parameters_fails_to_return_data.cpp )
target_link_libraries( request_get_parameters_fails_to_return_data_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( request_get_parameters_fails_to_return_data_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/request_get_parameters_fails_to_return_data_regression_test_suite )

add_executable( uri_fails_to_handle_file_scheme_relative_paths_regression_test_suite ${SOURCE_DIR}/uri_fails_to_handle_file_scheme_relative_paths.cpp )
target_link_libraries( uri_fails_to_handle_file_scheme_relative_paths_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( uri_fails_to_handle_file_scheme_relative_paths_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/uri_fails_to_handle_file_scheme_relative_paths_regression_test_suite )

add_executable( multiple_log_entries_regression_test_suite ${SOURCE_DIR}/multiple_log_entries.cpp )
target_link_libraries( multiple_log_entries_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( multiple_log_entries_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/multiple_log_entries_regression_test_suite )

add_executable( client_fails_to_calculate_correct_response_body_length_regression_test_suite ${SOURCE_DIR}/client_fails_to_calculate_correct_response_body_length.cpp )
target_link_libraries( client_fails_to_calculate_correct_response_body_length_regression_test_suite ${CMAKE_PROJECT_NAME} )
add_test( client_fails_to_calculate_correct_response_body_length_regression_test_suite ${EXECUTABLE_OUTPUT_PATH}/client_fails_to_calculate_correct_response_body_length_regression_test_suite )

=== test/unit/CMakeLists.txt ===
# Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.

project( "unit test suite" )

cmake_minimum_required( VERSION 2.8.10 )

#
# Configuration
#
set( SOURCE_DIR "source" )
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DCATCH_CONFIG_MAIN" )

include_directories( SYSTEM ${catch_INCLUDE} )

#
# Build
#
add_executable( uri_unit_test_suite ${SOURCE_DIR}/uri_suite.cpp )
target_link_libraries( uri_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( uri_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/uri_unit_test_suite )

add_executable( string_unit_test_suite ${SOURCE_DIR}/string_suite.cpp )
target_link_libraries( string_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( string_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/string_unit_test_suite )

add_executable( session_unit_test_suite ${SOURCE_DIR}/session_suite.cpp )
target_link_libraries( session_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( session_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/session_unit_test_suite )

add_executable( service_unit_test_suite ${SOURCE_DIR}/service_suite.cpp )
target_link_libraries( service_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( service_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/service_unit_test_suite )

add_executable( request_unit_test_suite ${SOURCE_DIR}/request_suite.cpp )
target_link_libraries( request_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( request_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/request_unit_test_suite )

add_executable( settings_unit_test_suite ${SOURCE_DIR}/settings_suite.cpp )
target_link_libraries( settings_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( settings_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/settings_unit_test_suite )

add_executable( response_unit_test_suite ${SOURCE_DIR}/response_suite.cpp )
target_link_libraries( response_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( response_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/response_unit_test_suite )

add_executable( resource_unit_test_suite ${SOURCE_DIR}/resource_suite.cpp )
target_link_libraries( resource_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( resource_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/resource_unit_test_suite )

add_executable( ssl_settings_unit_test_suite ${SOURCE_DIR}/ssl_settings_suite.cpp )
target_link_libraries( ssl_settings_unit_test_suite ${CMAKE_PROJECT_NAME} )
add_test( ssl_settings_unit_test_suite ${EXECUTABLE_OUTPUT_PATH}/ssl_settings_unit_test_suite )

=== debian/changelog ===
restbed (4.0~dfsg1-5build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:28:01 +0000

restbed (4.0~dfsg1-5) unstable; urgency=medium

  * Move to salsa.debian.org.

 -- Alexandre Viau <aviau@debian.org>  Fri, 29 Dec 2017 00:49:03 -0500

restbed (4.0~dfsg1-4) unstable; urgency=medium

  * d/watch: fix dversionmangle

 -- Alexandre Viau <aviau@debian.org>  Fri, 09 Sep 2016 10:12:33 -0400

restbed (4.0~dfsg1-3) unstable; urgency=medium

  * Added shlibs file
  * Install all .so files

 -- Alexandre Viau <aviau@debian.org>  Tue, 06 Sep 2016 17:13:53 -0400

restbed (4.0~dfsg1-2) unstable; urgency=medium

  * add d/copyright comment about CPL-2.0

 -- Alexandre Viau <aviau@debian.org>  Tue, 06 Sep 2016 16:59:33 -0400

restbed (4.0~dfsg1-1) unstable; urgency=medium

  * Initial release. (Closes: #836891)

 -- Alexandre Viau <aviau@debian.org>  Tue, 06 Sep 2016 13:50:13 -0400

=== debian/control ===
Source: restbed
Section: libs
Priority: extra
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Alexandre Viau <aviau@debian.org>
Build-Depends: debhelper (>= 9),
               cmake,
               libasio-dev,
               libssl-dev
Standards-Version: 3.9.8
Homepage: https://github.com/Corvusoft/restbed
Vcs-Git: https://salsa.debian.org/debian/restbed.git
Vcs-Browser: https://salsa.debian.org/debian/restbed

Package: librestbed-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         librestbed0 (=${binary:Version})
Provides: librestbed-dev
Description: asynchronous REST C++11 library - dev package
 Restbed is a comprehensive and consistent programming model for
 building applications that require seamless and secure
 communication over HTTP, with the ability to model a range of
 business processes, designed to target mobile, tablet, desktop
 and embedded production environments.
 .
 This package contains the static library and headers.

Package: librestbed0
Architecture: any
Provides: librestbed0
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: asynchronous REST C++11 library
 Restbed is a comprehensive and consistent programming model for
 building applications that require seamless and secure
 communication over HTTP, with the ability to model a range of
 business processes, designed to target mobile, tablet, desktop
 and embedded production environments.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- \
	    -DBUILD_TESTS=OFF \
	    -DBUILD_EXAMPLES=OFF \
	    -DBUILD_SSL=ON \
	    -DBUILD_SHARED=ON \
	    -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:
	dh_auto_install

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/restbed-$1\.tar\.gz/,repacksuffix=~dfsg1,dversionmangle=s/\~dfsg\d*$// \
  https://github.com/Corvusoft/restbed/tags .*/v?(\d\S*)\.tar\.gz

## restbed 4.0~dfsg1-5build1+8.0trisquel1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,12 @@
 # Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.
+cmake_minimum_required( VERSION 2.8.10 )
 
 project( "restbed" )
-
-cmake_minimum_required( VERSION 2.8.10 )
+set (restbed_VERSION_MAJOR 0)
+set (restbed_VERSION_MINOR 0.0)
+set (restbed_VERSION ${restbed_VERSION_MAJOR}.${restbed_VERSION_MINOR})
+set (PACKAGE_VERSION ${restbed_VERSION})
+set (VERSION "${restbed_VERSION}")
 
 #
 # Build Options
@@ -41,6 +45,10 @@
 
 add_library( ${PROJECT_NAME} ${BUILD_MANIFEST} )
 
+if ( BUILD_SHARED )
+    set_target_properties (${PROJECT_NAME} PROPERTIES SOVERSION ${restbed_VERSION_MAJOR} VERSION ${restbed_VERSION})
+endif ( )
+
 if ( BUILD_SSL )
     target_link_libraries( ${PROJECT_NAME} LINK_PRIVATE ${ssl_LIBRARY} ${crypto_LIBRARY} )
 else ( )
@@ -71,5 +79,5 @@
 install( FILES "${INCLUDE_DIR}/${PROJECT_NAME}" DESTINATION "include" )
 install( FILES ${BUILD_ARTIFACTS} DESTINATION "include/corvusoft/${PROJECT_NAME}" )
 install( TARGETS ${PROJECT_NAME}
-         LIBRARY DESTINATION "library"
-         ARCHIVE DESTINATION "library" COMPONENT library )
+         LIBRARY DESTINATION "lib"
+         ARCHIVE DESTINATION "lib" COMPONENT library )

=== .pc/usr-lib.patch/CMakeLists.txt ===
# Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.
cmake_minimum_required( VERSION 2.8.10 )

project( "restbed" )
set (restbed_VERSION_MAJOR 0)
set (restbed_VERSION_MINOR 0.0)
set (restbed_VERSION ${restbed_VERSION_MAJOR}.${restbed_VERSION_MINOR})
set (PACKAGE_VERSION ${restbed_VERSION})
set (VERSION "${restbed_VERSION}")

#
# Build Options
#
option( BUILD_SHARED   "Build shared library."              OFF )
option( BUILD_EXAMPLES "Build examples applications."       OFF )
option( BUILD_TESTS    "Build all available test suites."   OFF )
option( BUILD_SSL      "Build secure socket layer support."  ON )

#
# Configuration
#
include( "${CMAKE_SOURCE_DIR}/cmake/build_configuration.cmake" )

message( "   ${Blue}Copyright 2013-2016, Corvusoft Ltd, All Rights Reserved.${Reset}" )

#
# Dependencies
#
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules" )

find_package( asio REQUIRED )
include_directories( SYSTEM ${asio_INCLUDE} )

if ( BUILD_SSL )
    find_package( openssl REQUIRED )
    include_directories( SYSTEM ${ssl_INCLUDE} )
endif ( )

#
# Build
#
include( "${CMAKE_SOURCE_DIR}/cmake/build_manifest.cmake" )

include_directories( ${INCLUDE_DIR} )

add_library( ${PROJECT_NAME} ${BUILD_MANIFEST} )
set_target_properties (${PROJECT_NAME} PROPERTIES SOVERSION ${restbed_VERSION_MAJOR} VERSION ${restbed_VERSION})

if ( BUILD_SSL )
    target_link_libraries( ${PROJECT_NAME} LINK_PRIVATE ${ssl_LIBRARY} ${crypto_LIBRARY} )
else ( )
    target_link_libraries( ${PROJECT_NAME} )
endif ( )

if ( BUILD_EXAMPLES )
    find_package( pam )
    find_package( syslog )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/example" )
endif ( )

if ( BUILD_TESTS )
    find_package( catch REQUIRED )

    enable_testing( )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/unit" "unit-tests" )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/acceptance" "acceptance-tests" )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/regression" "regression-tests" )
    add_subdirectory( "${CMAKE_SOURCE_DIR}/test/integration" "integration-tests" )
endif ( )

#
# Install
#
include( "${CMAKE_SOURCE_DIR}/cmake/build_artifacts.cmake" )

install( FILES "${INCLUDE_DIR}/${PROJECT_NAME}" DESTINATION "include" )
install( FILES ${BUILD_ARTIFACTS} DESTINATION "include/corvusoft/${PROJECT_NAME}" )
install( TARGETS ${PROJECT_NAME}
         LIBRARY DESTINATION "library"
         ARCHIVE DESTINATION "library" COMPONENT library )

=== debian/changelog ===
restbed (4.0~dfsg1-5build1+8.0trisquel1) flidas; urgency=medium

  * Backported from bionic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 08 Oct 2018 20:13:56 +0000
